/**
 * Create redux-arena proxy store
 */
import { createStore, combineReducers } from "redux";

function storeEnhancer(store, reducers) {
  var _currentReducers = reducers;
  var handler = {
    get: function get(target, name) {
      if (name === "addReducer") {
        return function (_ref) {
          var _Object$assign;

          var reducerKey = _ref.reducerKey,
              reducer = _ref.reducer;

          var allStates = target.getState();
          if (allStates.arena.stateTreeDict.get(reducerKey) != null) return false;
          _currentReducers = Object.assign({}, _currentReducers, (_Object$assign = {}, _Object$assign[reducerKey] = reducer, _Object$assign));
          target.replaceReducer(combineReducers(_currentReducers));
          return true;
        };
      }
      if (name === "removeReducer") {
        return function (reducerKey) {
          if (reducerKey == null) {
            throw new Error("Can not remove reducerKey of null.");
            return false;
          }
          var newReducers = Object.assign({}, _currentReducers);
          var allStates = target.getState();
          delete newReducers[reducerKey];
          _currentReducers = newReducers;
          delete allStates[reducerKey];
          target.replaceReducer(combineReducers(newReducers));
          return true;
        };
      }
      if (name === "replaceReducer") {
        return function (_ref2) {
          var _Object$assign2;

          var reducerKey = _ref2.reducerKey,
              reducer = _ref2.reducer;

          if (reducerKey == null) throw new Error("reducerKey can not be null.");
          var allStates = target.getState();
          if (_currentReducers[reducerKey] == null) throw new Error("reducer for key [" + reducerKey + "] doesn't exsit.");
          _currentReducers = Object.assign({}, _currentReducers, (_Object$assign2 = {}, _Object$assign2[reducerKey] = reducer, _Object$assign2));
          target.replaceReducer(combineReducers(_currentReducers));
          return reducerKey;
        };
      }
      return target[name];
    }
  };
  return new Proxy(store, handler);
}

export default function createEnhancedStore(reducers, initialState, enhencer) {
  var store = createStore(combineReducers(reducers), initialState, enhencer);
  return storeEnhancer(store, reducers);
}