function defaultPropsPicker(sceneState, sceneActions) {
  return Object.assign({}, sceneState, {
    actions: sceneActions
  });
}

export default function createPropsPicker() {
  var propsPicker = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultPropsPicker;
  var reduxInfo = arguments[1];
  var mutableObj = arguments[2];
  var arenaReducerDict = reduxInfo.arenaReducerDict;

  var sceneReducerKey = arenaReducerDict._arenaScene.reducerKey;
  var sceneActions = arenaReducerDict._arenaScene.actions;
  var latestProps = void 0;
  return function (state) {
    if (mutableObj.isObsolete === true || state.arena.propsLock !== false || state.arena.stateTreeDict.getIn([sceneReducerKey, "isObsolete"]) === true) {
      return latestProps;
    } else {
      latestProps = propsPicker(state[sceneReducerKey], sceneActions, state, arenaReducerDict);
      return latestProps;
    }
  };
}