import { ARENA_SCENE_SET_STATE, ARENA_SCENE_REPLACE_STATE } from "../actionTypes.js";
import getSceneInitState from "./getSceneInitState";

function sceneReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : getSceneInitState();
  var action = arguments[1];
  var sceneReducerKey = arguments[2];

  if (action._sceneReducerKey !== sceneReducerKey) return state;
  switch (action.type) {
    case ARENA_SCENE_SET_STATE:
      return Object.assign({}, state, action.state);
    case ARENA_SCENE_REPLACE_STATE:
      return Object.assign({}, action.state);
    default:
      return state;
  }
}

export default function createSceneReducer(extendSceneReducer, initState, sceneReducerKey) {
  return function () {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initState;
    var action = arguments[1];

    if (extendSceneReducer) {
      state = extendSceneReducer(state, action, sceneReducerKey);
    }
    return sceneReducer(state, action, sceneReducerKey);
  };
}