"use strict";

exports.__esModule = true;
exports.default = createSceneReducer;

var _actionTypes = require("../actionTypes.js");

var _getSceneInitState = require("./getSceneInitState");

var _getSceneInitState2 = _interopRequireDefault(_getSceneInitState);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function sceneReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : (0, _getSceneInitState2.default)();
  var action = arguments[1];
  var sceneReducerKey = arguments[2];

  if (action._sceneReducerKey !== sceneReducerKey) return state;
  switch (action.type) {
    case _actionTypes.ARENA_SCENE_SET_STATE:
      return Object.assign({}, state, action.state);
    case _actionTypes.ARENA_SCENE_REPLACE_STATE:
      return Object.assign({}, action.state);
    default:
      return state;
  }
}

function createSceneReducer(extendSceneReducer, initState, sceneReducerKey) {
  return function () {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initState;
    var action = arguments[1];

    if (extendSceneReducer) {
      state = extendSceneReducer(state, action, sceneReducerKey);
    }
    return sceneReducer(state, action, sceneReducerKey);
  };
}