"use strict";

exports.__esModule = true;
exports.default = saga;

var _effects = require("redux-saga/effects");

var _actionTypes = require("../actionTypes");

var _marked = /*#__PURE__*/regeneratorRuntime.mark(initAudienceSaga),
    _marked2 = /*#__PURE__*/regeneratorRuntime.mark(saga);

/**
 *This function is run at the beginning of the incoming saga, and then saved in the arena
 * 
 * @param {any} { saga } 
 */
function initAudienceSaga(_ref) {
  var saga = _ref.saga;
  var newAudienceSagaTask;
  return regeneratorRuntime.wrap(function initAudienceSaga$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          _context.next = 2;
          return (0, _effects.fork)(saga);

        case 2:
          newAudienceSagaTask = _context.sent;
          _context.next = 5;
          return (0, _effects.put)({
            type: _actionTypes.ARENA_SET_STATE,
            state: {
              audienceSagaTask: newAudienceSagaTask
            }
          });

        case 5:
        case "end":
          return _context.stop();
      }
    }
  }, _marked, this);
}

function saga() {
  return regeneratorRuntime.wrap(function saga$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          _context2.next = 2;
          return (0, _effects.takeLatest)(_actionTypes.ARENA_INIT_AUDIENCE_SAGA, initAudienceSaga);

        case 2:
        case "end":
          return _context2.stop();
      }
    }
  }, _marked2, this);
}