"use strict";

exports.__esModule = true;

var _effects = require("redux-saga/effects");

var _getArenaReducerDictEntry = require("./getArenaReducerDictEntry");

var _getArenaReducerDictEntry2 = _interopRequireDefault(_getArenaReducerDictEntry);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _marked = /*#__PURE__*/regeneratorRuntime.mark(_putSceneAction),
    _marked2 = /*#__PURE__*/regeneratorRuntime.mark(_putSceneActionResolve);

function _putSceneAction(action, key) {
  var entry, newAction;
  return regeneratorRuntime.wrap(function _putSceneAction$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          _context.next = 2;
          return (0, _getArenaReducerDictEntry2.default)(key);

        case 2:
          entry = _context.sent;
          newAction = Object.assign({}, action, {
            _sceneReducerKey: entry.reducerKey
          });
          _context.next = 6;
          return (0, _effects.put)(newAction);

        case 6:
        case "end":
          return _context.stop();
      }
    }
  }, _marked, this);
}

function _putSceneActionResolve(actionPromise, key) {
  var action, entry, newAction;
  return regeneratorRuntime.wrap(function _putSceneActionResolve$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          _context2.next = 2;
          return actionPromise;

        case 2:
          action = _context2.sent;
          _context2.next = 5;
          return (0, _getArenaReducerDictEntry2.default)(key);

        case 5:
          entry = _context2.sent;
          newAction = Object.assign({}, action, {
            _sceneReducerKey: entry.reducerKey
          });
          _context2.next = 9;
          return (0, _effects.put)(newAction);

        case 9:
        case "end":
          return _context2.stop();
      }
    }
  }, _marked2, this);
}

var putSceneAction = function putSceneAction(action) {
  var key = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "_arenaScene";

  return (0, _effects.call)(_putSceneAction, action, key);
};

putSceneAction.resolve = function (actionPromise) {
  var key = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "_arenaScene";

  return (0, _effects.call)(_putSceneActionResolve, actionPromise, key);
};

exports.default = putSceneAction;