"use strict";

exports.__esModule = true;

exports.default = function () {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _state2.default;
  var action = arguments[1];
  var sceneReducerKey = arguments[2];

  if (action._sceneReducerKey !== sceneReducerKey) return state;
  switch (action.type) {
    case _actionTypes.ARENA_SCENE_ANIMATION_NEXTPHRASE:
      if (state.phase !== action.phase) return state;
      switch (state.phase) {
        case _animationPhase.LOADING:
          return Object.assign({}, state, {
            phase: _animationPhase.ENTERING
          });
        case _animationPhase.ENTERING:
          return Object.assign({}, state, {
            phase: _animationPhase.IN
          });
        case _animationPhase.LEAVING:
          return Object.assign({}, state, { phase: _animationPhase.OUT });
        case _actionTypes.ARENA_SCENE_ANIMATION_LEAVING_START:
          if (state.phase === _animationPhase.IN) return Object.assign({}, state, { phase: _animationPhase.LEAVING });
        default:
          return state;
      }
    default:
      return state;
  }
};

var _state = require("./state");

var _state2 = _interopRequireDefault(_state);

var _actionTypes = require("./actionTypes");

var _animationPhase = require("./animationPhase");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }