"use strict";

exports.__esModule = true;
exports.default = _callee;

var _effects = require("../../effects");

var _actionTypes = require("./actionTypes");

var _animationPhase = require("./animationPhase");

var _marked = /*#__PURE__*/regeneratorRuntime.mark(loadSceneBundle),
    _marked2 = /*#__PURE__*/regeneratorRuntime.mark(_callee);

/**
 * The asynchronous loading function of the scene, 
 * and finally the synchronous load function
 * 
 * @param {any} { arenaReducerDict, asyncSceneBundle } 
 * @returns 
 */
function loadSceneBundle(_ref) {
  var asyncBundleThunk = _ref.asyncBundleThunk;
  var bundleModule, bundle;
  return regeneratorRuntime.wrap(function loadSceneBundle$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          _context.next = 2;
          return (0, _effects.setSceneState)({
            isSceneReady: false,
            phase: _animationPhase.LOADING,
            bundle: null
          });

        case 2:
          _context.next = 4;
          return asyncBundleThunk();

        case 4:
          bundleModule = _context.sent;
          bundle = bundleModule.default ? bundleModule.default : bundleModule;
          _context.next = 8;
          return (0, _effects.setSceneState)({
            isSceneReady: true,
            bundle: bundle
          });

        case 8:
        case "end":
          return _context.stop();
      }
    }
  }, _marked, this);
}

function _callee() {
  return regeneratorRuntime.wrap(function _callee$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          _context2.next = 2;
          return (0, _effects.takeLatestSceneAction)(_actionTypes.ARENA_SCENE_ANIMATION_LOAD_BUNDLE, loadSceneBundle);

        case 2:
        case "end":
          return _context2.stop();
      }
    }
  }, _marked2, this);
}